#include<utility>

    long long value(int r, int c);

    int p[505][505];

    int get(int r, int c) {
        if (p[r][c]) {
            return p[r][c];
        } else {
            p[r][c] = value(r, c);
            return p[r][c];
        }
    }

    std::pair<int, int> find_locmin_point(int N, int M) {
        for (int i = 0; i <= N; i++) {
            for (int j = 0; j <= M; j++) {
                p[i][j] = 0;
            }
        }
        int i = 1;
        int j = 1;
        while (true) {
            if (i + 1 <= N) {
                if (get(i + 1, j) < get(i, j)) {
                    i++;
                }
            }

            if (j + 1 <= M) {
                if (get(i, j + 1) < get(i, j)) {
                    j++;
                }
            }

            if (i - 1 > 0) {
                if (get(i - 1, j) < get(i, j)) {
                    i--;
                }
            }

            if (j - 1 > 0) {
                if (get(i, j - 1) < get(i, j)) {
                    j--;
                }
            }
        }
        return {i, j};
    }